# CodeCombat

<div style="text-align:center">
  <a href="http://codecombat.com/">
    <img src ="https://s3.amazonaws.com/files.codecombat.com/wiki-images/readme_00.png" />
  </a>
</div>

[![Build Status](https://travis-ci.org/codecombat/codecombat.png?branch=master)](https://travis-ci.org/codecombat/codecombat)
[![Coverage Status](https://coveralls.io/repos/github/codecombat/codecombat/badge.svg)](https://coveralls.io/github/codecombat/codecombat)

CodeCombat is a multiplayer programming game for learning how to code.
**See the [Archmage (coder) developer wiki](../../wiki/Archmage-Home) for a dev
setup guide, extensive documentation, and much more to get started hacking!**

It's both a startup and a community project, completely open source under the
[MIT and Creative Commons licenses](http://codecombat.com/legal). It's the
largest open source [CoffeeScript](http://coffeescript.org/) project by lines of
code, and since it's a game (with [really cool tech](../../wiki/Third-party-software-and-services)),
it's really fun to hack on. Join us in teaching the world to code! Your
contribution will go on to show millions of players how cool programming can be.

### [Getting Started](../../wiki/Dev-Setup:-General-Information)

We've made it easy to fork the project, run a simple script that'll install all
the dependencies, and get a local copy of CodeCombat running right away on
[Mac](../../wiki/Dev-Setup:-Mac), [Linux](../../wiki/Dev-Setup:-Linux),
[Windows](../../wiki/Dev-Setup:-Windows), or [Vagrant](../../wiki/Dev-Setup:-Vagrant).
See [the docs for details](../../wiki/Dev-Setup:-General-Information).

### [Getting In Touch](../../wiki/Developer-organization)

Whether you're novice or pro, the CodeCombat team is ready to help you implement
your ideas. Reach out on our [forum](http://discourse.codecombat.com), our
[issue tracker](../../issues), or
[our developer chat room on Slack](https://coco-slack-invite.herokuapp.com/), or
see the docs for [more on how to contribute](../../wiki/Developer-organization).

[![Slack Status](https://coco-slack-invite.herokuapp.com/badge.svg)](https://coco-slack-invite.herokuapp.com/)

### [License](LICENSE)

[MIT](LICENSE) for the code, and [CC-BY](http://codecombat.com/legal) for the
art and music. Please also
[sign the CodeCombat contributor license agreement](http://codecombat.com/cla)
so we can accept your pull requests. It is easy.

### [Join Us!](http://blog.codecombat.com/why-you-should-open-source-your-startup)

![Nick Winter](http://codecombat.com/images/pages/about/team-avatars/nick-avatar.png "Nick Winter")
![George Saines](http://codecombat.com/images/pages/about/george_small.png "George Saines")
![Scott Erickson](http://codecombat.com/images/pages/about/team-avatars/scott-avatar.png "Scott Erickson")
![Matt Lott](http://codecombat.com/images/pages/about/team-avatars/matt-avatar.png "Matt Lott")
![Catherine Weresow](http://codecombat.com/images/pages/about/team-avatars/cat-avatar.png "Catherine Weresow")
![Maka Gradin](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Maka%20Gradin/maka_gradin_100.png "Maka Gradin")
![Rob Blanckaert](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Rob%20Blanckaert/rob_blanckaert_100.png "Rob Blanckaert")
![Josh Callebaut](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Josh%20Callebaut/josh_callebaut_100.png "Josh Callebaut")
![Michael Schmatz](http://codecombat.com/images/pages/about/michael_small.png "Michael Schmatz")
![Josh Lee](http://codecombat.com/images/pages/about/josh_small.png "Josh Lee")
![Dan TDM](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Dan_TDM/dan_tdm_100.png "Dan TDM")
![Alex Cotsarelis](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Alex%20Cotsarelis/alex_100.png "Alex Cotsarelis")
![Alex Crooks](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Alex%20Crooks/alex_100.png "Alex Crooks")
![Alexandru Caciulescu](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Alexandru%20Caciulescu/alexandru_100.png "Alexandru Caciulescu")
![Andreas Linn](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Andreas%20Linn/andreas_100.png "Andreas Linn")
![Andrew Witcher](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Andrew%20Witcher/andrew_100.png "Andrew Witcher")
![Axandre Oge](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Axandre%20Oge/axandre_100.png "Axandre Oge")
![Bang Honam](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Bang%20Honam/bang_100.png "Bang Honam")
![Benjamin Stern](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Benjamin%20Stern/benjamin_100.png "Benjamin Stern")
![Brad Dickason](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Brad%20Dickason/brad_100.png "Brad Dickason")
![Carlos Maia](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Carlos%20Maia/carlos_maia_100.png "Carlos Maia")
![Chloe Fan](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Chloe%20Fan/chloe_100.png "Chloe Fan")
![Dan Ristic](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Dan%20Ristic/dan_100.png "Dan Ristic")
![Danny Whittaker](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Danny%20Whittaker/danny_100.png "Danny Whittaker")
![David Liu](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/David%20Liu/david_liu_100.png "David Liu")
![David Pendray](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/David%20Pendray/david_100.png "David Pendray")
![Deepak1556](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Deepak1556/deepak_100.png "Deepak1556")
![Derek Wong](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Derek%20Wong/derek_100.png "Derek Wong")
![Dominik Kundel](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Dominik%20Kundel/dominik_k_100.png "Dominik Kundel")
![Glen De Cauwsemaecker](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Glen%20de%20Cauwsemaecker/glen_100.png "Glen De Cauwsemaecker")
![Ian Li](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Ian%20Li/ian_100.png "Ian Li")
![Jeremy Arns](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Jeremy%20Arns/jeremy_100.png "Jeremy Arns")
![Joachim Brehmer](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Joachim%20Brehmer/joachim_100.png "Joachim Brehmer")
![Jose Antonini](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Jose%20Antonini/jose_antonini_100.png "Jose Antonini")
![Katharine Chan](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Katharine%20Chan/katharine_100.png "Katharine Chan")
![Ken Stanley](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Ken%20Stanley/ken_100.png "Ken Stanley")
![Kevin Holland](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Kevin%20Holland/kevin_100.png "Kevin Holland")
![Laura Watiker](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Laura%20Watiker/laura_100.png "Laura Watiker")
![Michael Heasell](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Michael%20Heasell/michael_100.png "Michael Heasell")
![Michael Polyak](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Michael%20Polyak/michael_100.png "Michael Polyak")
![Mischa Lewis-Norelle](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Mischa%20Lewis-Norelle/mischa_100.png "Mischa Lewis-Norelle")
![Nathan Gosset](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Nathan%20Gosset/nathan_100.png "Nathan Gosset")
![Oleg Ulyanicky](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Oleg%20Ulyanickiy/oleg_100.png "Oleg Ulyanicky")
![Paul Buser](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Paul%20Buser/paul_100.png "Paul Buser")
![Pavel Konstantynov](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Pavel%20Konstantinov/pavel_100.png "Pavel Konstantynov")
![Popey Gilbert](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Popey%20Gilbert/popey_100.png "Popey Gilbert")
![Prabhsimran Baweja](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Prabhsimran%20Baweja/prabhsimran_100.png "Prabhsimran Baweja")
![Rachel Xiang](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Rachel%20Xiang/rachel_100.png "Rachel Xiang")
![Rebecca Saines](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Rebecca%20Saines/rebecca_100.png "Rebecca Saines")
![Robert Moreton](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Robert%20Moreton/robert_100.png "Robert Moreton")
![Ronnie Cheng](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Ronnie%20Cheng/ronnie_100.png "Ronnie Cheng")
![Ruben Vereecken](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Ruben%20Vereecken/ruben_100.png "Ruben Vereecken")
![Russ Fan](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Russ%20Fan/russ_100.png "Russ Fan")
![Shiying Zheng](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Shying%20Zheng/shiyeng_100.png "Shiying Zheng")
![Sébastien Moratinos](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Tom%20Steinbrecher/tom_100.png "Sébastien Moratinos")
![Thanish Muhammed](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Thanish%20Muhammed/thanish_100.png "Thanish Muhammed")
![Tom Steinbrecher](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Tom%20Steinbrecher/tom_100.png "Tom Steinbrecher")
![Yang Shun Tay](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Yang%20Shun%20Tay/yang_shun_tay_100.png "Yang Shun Tay")
![Zach Martin](https://s3.amazonaws.com/files.codecombat.com/wiki-images/avatars/Zach%20Martin/zack_100.png "Zach Martin")
