#### Activity
# Introduction to Data Analysis
Computational Artifact Activity, Inquiry Activity
 
### Learning Objectives:

- [LO 1.1.1] Apply a creative development process when creating computational artifacts. [P2]
- [LO 1.2.2] Create a computational artifact using computing tools and techniques to solve a problem. [P2]
- [LO 1.2.3] Create a new computational artifact by combining or modifying existing artifacts. [P2]
- [LO 1.2.4] Collaborate in the creation of computational artifacts. [P6]
- [LO 3.1.1] Find patterns and test hypotheses about digitally processed information to gain insight and knowledge. [P4]
- [LO 3.1.2] Collaborate when processing information to gain insight and knowledge. [P6]
- [LO 3.1.3] Explain the insight and knowledge gained from digitally processed data by using appropriate visualizations, notations, and precise language. [P5]
- [LO 3.2.1] Extract information from data to discover and explain connections or trends. [P1]

**Where have you seen data used to communicate a point?**

Ask students for instances where they have seen data provided as evidence for a point of view. For each instance, ask:

* How is the data presented? (pie graph, bar graph, raw numbers, etc)
* Did the data have to be transformed in some way? (averages, medians, adjusted for inflation, trendline, etc)
* What is the point that the presenter of the information is trying to get across?

**Spreadsheets How To**

Give students an introduction to your spreadsheet software of choice, such as Microsoft Excel or Google Sheets. Take a sample of data and show how formulas can be used to transform data, and graphs can be used to visualize data. For formulas, be sure to demonstrate functions which are corollaries to the ones they have been learning in CodeCombat, such as the Logical functions listed in the Google spreadsheets function list (OR, IF, etc).

**Finding Data**

Walk students through finding some data to study. Ask students for data that they would be interested in looking at. For each sort of data, work as a group to find that data on the web and practice asking questions of or making hypotheses about that data. Alternatively, go to sites which list data sources and dig into ones which spark student interest. For example:

* https://www.data.gov/
* https://www.google.com/publicdata/directory
* https://aws.amazon.com/public-datasets/

**Data Project**

Students will work with a partner to answer a question of interest. Have students choose a dataset to study and a question to answer from it. Guide students in iteratively making hypotheses and testing those hypotheses with statistical tools. Students will extract information from their data, create data visualizations, process the information, and make conclusions. Finally, have students present their findings to the rest of the class, including how they processed the data to arrive at their conclusion..

This project should take four class periods - one to plan the project and locate data, one to extract information and create visualizations, one to process the information and make conclusions, and one to present their work.
 
### Discussion Questions:
- How did you decide on the layout and visualizations for your website? How do your design decisions showcase the data?
- How did your partner help you gain additional insight from the data?
- How did your hypothesis compare to your findings?

### Assessment Questions:
- What data did you use for your project? What did you learn from analyzing the data? [EK 3.1.1D, LO 3.2.1]
- Describe a part of your data crunching which was iterative. How did one discovery lead to another? [EK 3.1.1A]
- What transformations did you act on your data to find your conclusion? [3.1.1E]
- What parts of the project did you and your partner collaborate on? [LO 3.1.2]
- Why did you choose to display your data the way you did? [LO 3.1.3]
